package com.kingdee.eas.custom.calcdailypay.task;

import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.EASResource;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillCollection;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillEntryCollection;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillEntryFactory;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillFactory;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillInfo;
import com.kingdee.shr.compensation.app.integrate.CalSubmitSchemeFactory;
import com.kingdee.shr.compensation.app.integrate.CalSubmitSchemeInfo;
import com.kingdee.shr.compensation.app.integrate.IBatchSubmitShemeBill;
import com.kingdee.shr.compensation.app.integrate.IBatchSubmitShemeBillEntry;
import com.kingdee.shr.compensation.integrate.verify.CycleVerify;
import com.kingdee.shr.compensation.integrate.verify.ISubmitBillVerifyInterface;
import com.kingdee.shr.compensation.integrate.verify.SubmitBillDisableElementVerify;
import com.kingdee.shr.compensation.integrate.verify.SubmitBillEnableElementVerify;
import com.kingdee.shr.compensation.util.budget.BudgetUtil;
import com.kingdee.shr.compensation.web.handler.integrate.helper.CmpIntegrateWebHelper;
import com.google.common.collect.Maps;
import org.apache.log4j.Logger;
import javax.ejb.*;
import com.kingdee.bos.*;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.Map;

import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.util.app.DbUtil;

public class AutoSubDayDetailFacadeControllerBean extends AbstractAutoSubDayDetailFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.calcdailypay.task.AutoSubDayDetailFacadeControllerBean");




    /**
     *
     * @param ctx
     * @param preCalcDays ƫʾƣʾǰ
     * @throws BOSException
     * @throws EASBizException
     */
    public void _autoSubDayDetail(Context ctx, int preCalcDays) throws BOSException, EASBizException {
        // ȡǰ
        LocalDate currentDate = LocalDate.now();
        // preCalcDaysʼںͽ
        LocalDate startDate = currentDate.minusDays(Math.abs(preCalcDays));
        LocalDate endDate = currentDate.plusDays(preCalcDays >= 0 ? preCalcDays : 0);

        // preCalcDaysstartDateendDate˳
        if (preCalcDays < 0) {
            LocalDate temp = startDate;
            startDate = endDate;
            endDate = temp;
        }

        // ڷΧÿִһexecuteSubmit
        while (!startDate.isAfter(endDate)) {
            executeSubmit(ctx, startDate);
            startDate = startDate.plusDays(1);
        }
    }

    private void executeSubmit(Context ctx, LocalDate date) throws BOSException, EASBizException {
        // executeSubmitľʵ
        // ҪڸʽΪضʽ
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        String formattedDate = date.format(formatter);
        //ҵ߼
		IBatchSubmitShemeBill billIns = BatchSubmitShemeBillFactory.getLocalInstance(ctx);
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("billState", HRBillStateEnum.SAVED_VALUE, CompareType.EQUALS));
        filter.getFilterItems().add(new FilterItemInfo("applyDate",  formattedDate , CompareType.LESS_EQUALS));
        filter.getFilterItems().add(new FilterItemInfo("applyDate",  formattedDate , CompareType.GREATER_EQUALS  ));
        EntityViewInfo viewInfo = new EntityViewInfo();
       
        viewInfo.setFilter(filter);
        try {
        	BatchSubmitShemeBillCollection batchSubmitShemeBillCollection = billIns.getBatchSubmitShemeBillCollection(viewInfo);
        	if (!batchSubmitShemeBillCollection.isEmpty()) {
        		for (int i = 0; i < batchSubmitShemeBillCollection.size(); ++i) {
        			BatchSubmitShemeBillInfo model = batchSubmitShemeBillCollection.get(i);
        			beforeSubmit( ctx, model);
        			billIns.submitEffect(model);
        		}
        	}
        } catch (SHRWebException e) {
        	logger.error(e);
        }
    }
    

    
    ////////////DefaultSubmitShemeBillListHandler_beforeSubmit////////////
    protected void beforeSubmit( Context ctx,CoreBaseInfo model)
    		throws SHRWebException {
    	model.setInt("billState", 1);
    	BatchSubmitShemeBillInfo info = (BatchSubmitShemeBillInfo) model;
    	
    	this.reAssembleModel(ctx, info);
    	this.verifyIsBillEntryEmpty(ctx, info);
    	
    	try {
    		ISubmitBillVerifyInterface verifyInstance = this.getVerifyInstance(ctx, info);
    		verifyInstance.verify(ctx, info, this.getVerifyParams());
    		BudgetUtil.verifyBudget(ctx, info);
    	} catch (BOSException var8) {
    		throw new SHRWebException(var8.getMessage(), var8);
    	} catch (EASBizException var9) {
    		throw new ShrWebBizException(var9.getMessage(), var9);
    	}
    	
    	try {
    		this.udpSubmitTime(ctx, info.getId().toString());
    	} catch (BOSException var7) {
    		throw new SHRWebException(var7.getMessage(), var7);
    	}
    }
    
    protected void reAssembleModel(Context ctx, BatchSubmitShemeBillInfo model) throws SHRWebException {
    	String oql = "select *, entry.*,submitScheme.id,entry.submitElement.name,entry.person.name,entry.person.number where id = '%s'";
    	BatchSubmitShemeBillInfo info = CmpIntegrateWebHelper.getBatchSubmitShemeBillInfo(ctx,
    			String.format(oql, model.getId().toString()));
    	model.clear();
    	model.putAll(info);
    }
    
    
    protected void verifyIsBillEntryEmpty(Context ctx, BatchSubmitShemeBillInfo info) throws SHRWebException {
    	if (info.getEntry() == null || info.getEntry().isEmpty()) {
    		throw new ShrWebBizException(EASResource.getString(
    				"com.kingdee.shr.compensation.resource.SubmitShemeBillResource", "label19", ctx.getLocale()));
    	}
    }
    
    
    protected ISubmitBillVerifyInterface getVerifyInstance(Context ctx, BatchSubmitShemeBillInfo info)
    		throws SHRWebException {
    	if (null == info) {
    		throw new ShrWebBizException("model can not be null.");
    	} else {
    		try {
    			CalSubmitSchemeInfo calSubmitSchemeInfo = CalSubmitSchemeFactory.getLocalInstance(ctx)
    					.getCalSubmitSchemeInfo(new ObjectUuidPK(info.getSubmitScheme().getId().toString()));
    			ISubmitBillVerifyInterface instance = this
    					.createVerifyInstance(calSubmitSchemeInfo.isIsEnableSubmitElement());
    			if (calSubmitSchemeInfo.isIscycle()) {
    				instance = new CycleVerify((ISubmitBillVerifyInterface) instance);
    			}
    			
    			return (ISubmitBillVerifyInterface) instance;
    		} catch (EASBizException var5) {
    			throw new ShrWebBizException(var5.getMessage(), var5);
    		} catch (BOSException var6) {
    			throw new SHRWebException(var6.getMessage(), var6);
    		}
    	}
    }
    
    protected ISubmitBillVerifyInterface createVerifyInstance(boolean isEnableSubmitElement) {
    	return (ISubmitBillVerifyInterface) (isEnableSubmitElement
    			? new SubmitBillEnableElementVerify()
    					: new SubmitBillDisableElementVerify());
    }
    
    
    protected Map<String, Object> getVerifyParams() {
    	return Maps.newHashMap();
    }
    
    
    
    protected void udpSubmitTime(Context ctx, String billId) throws BOSException {
    	String sql = "update T_HR_SBatchSubmitShemeBill set FSubmitTime = ? where FID = ?";
    	Object[] param = new Object[]{new Date((new Date()).getTime()), billId};
    	DbUtil.execute(ctx, sql, param);
    }
		
		
		
}



