package com.kingdee.shr.compensation.service;

import com.kingdee.bos.Context;
import com.kingdee.eas.basedata.hraux.BasicItemInfo;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.util.db.CmpInSql;
import com.kingdee.shr.compensation.util.db.CmpInSqlFactory;
import com.kingdee.shr.rpts.ctrlreport.osf.OSFExecutor;
import com.kingdee.shr.validaterule.formula.SalaryCalFunction2;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CalSubmitCusFunctionService extends SalaryCalFunction2 {
	private static final Logger logger = LoggerFactory.getLogger(CalSubmitCusFunctionService.class);
	private final SimpleDateFormat sdf_yyyy_MM_dd = new SimpleDateFormat("yyyy-MM-dd");
	private static final String EARLIEST_EFFDT = "1900-01-01";
	private static final String MAX_ENDDATE = "2199-12-31";

	 

	public double getAtsDataWithSubOrg(Context ctx, Map<String, Object> paramMap, HashMap<String, Object> tempMap,
			String mainTableName, String mainTableRowFilter, String project, double isVac, String company,
			double needSubOrg, double relativePeriod) {
		boolean haveSubOrg = 1.0D == needSubOrg;
		boolean vacProject = 1.0D == isVac;
		String key = "AtsResult:" + project + "-" + company + "-" + needSubOrg + "-" + isVac + "-" + relativePeriod;
		Map<String, List<Object>> mapData = null;
		List<Object> listData = null;
		Map dateMap;
		
		if (tempMap.get(key) == null) {
			Map<String, Map<String, String>> dataMap = this.getSubDataGroupByEffectDate(ctx, mainTableName,
					mainTableRowFilter, relativePeriod);
			if (dataMap.isEmpty() || ((Map) dataMap.get("sqlMap")).isEmpty()) {
				return 0.0D;
			}

			Map<String, String> sqlMap = (Map) dataMap.get("sqlMap");
			dateMap = (Map) dataMap.get("effectDateMap");
			Iterator<String> iterator = sqlMap.keySet().iterator();
			HashMap param = new HashMap();

			while (iterator.hasNext()) {
				String dateKey = (String) iterator.next();
				String rangeSql = (String) sqlMap.get(dateKey);
				String[] yearAndMonth = dateKey.split("-");
				param.put("year", yearAndMonth[0]);
				param.put("month", yearAndMonth[1]);
				param.put("times", yearAndMonth[2]);
				String l = ctx.getLocale().getLanguage();
				String companyLongNumber = "";
				if(!StringUtils.isEmpty(company)) {
					companyLongNumber = " select fLongNumber from T_ORG_ADMIN where fid in   (select FADMINORGID  from T_ORG_ADMINORGtreehis where fDisplayName_"
							+ l + " = '" + company + "') ";
				}
				param.put("companyLongNumber", Base64Utils.encodeWithSalt(companyLongNumber));
				param.put("personIds", Base64Utils.encodeWithSalt(rangeSql));
				param.put("haveSubOrg", haveSubOrg);
				param.put("attendProject", project);
				List tempListData;
				if (!vacProject) {
					tempListData = (List) OSFExecutor.executeOSF(ctx, param, "getAttendSumByHrOrg");
				} else {
					tempListData = (List) OSFExecutor.executeOSF(ctx, param, "getDayAttendData");
				}

				if (tempListData != null) {
					if (mapData == null) {
						mapData = new HashMap();
					}

					listData = (List) mapData.get(dateKey);
					if (listData == null) {
						listData = new ArrayList();
						mapData.put(dateKey, listData);
					}

					((List) listData).addAll(tempListData);
				}
			}

			tempMap.put(key, mapData);
			tempMap.put(key + "-effectDate", dateMap);
		}

		String personId = (String) paramMap.get(mainTableName.toUpperCase() + "_FPERSONID");
		String id = (String) paramMap.get(mainTableName.toUpperCase() + "_FID");
		dateMap = (Map) tempMap.get(key + "-effectDate");
		String dateKey = (String) dateMap.get(id);
		Map<String, List<Object>> resultData = (Map) tempMap.get(key);

		HashMap<String, Object> atsResultMap = null;
		if (null != resultData && null != resultData.get(dateKey) && !((List) resultData.get(dateKey)).isEmpty()) {
			List<Object> atsResultData = (List) resultData.get(dateKey);
			Iterator i = atsResultData.iterator();

			while (i.hasNext()) {
				HashMap<String, Object> map = (HashMap) i.next();
				dateKey = map.containsKey("personId") ? map.get("personId").toString() : "";
				if (dateKey.equals(personId)) {
					atsResultMap = map;
					break;
				}
			}
		}

		if (null != atsResultMap) {
			double res = 0.0D;
			if (null != atsResultMap.get(project) && !"".equals(atsResultMap.get(project))) {
				res = Double.parseDouble(atsResultMap.get(project).toString());
			}

			return res;
		} else {
			return 0.0D;
		}
	}

	public Map<String, Map<String, String>> getSubDataGroupByEffectDate(Context ctx, String mainTableName,
			String mainTableRowFilter, double relativePeriod) {
		String sql = "select FID, FEffectDate, FPersonID from " + mainTableName + " where FID in (" + mainTableRowFilter
				+ ")";
		Map<String, List<String>> effectDateMap = new HashMap();
		Map<String, String> sqlMap = new HashMap();
		Map<String, String> dateMap = new HashMap();
		HashMap dataMap = new HashMap();

		try {
			IRowSet executeQuery = DbUtil.executeQuery(ctx, sql);
			if (null != executeQuery) {
				while (executeQuery.next()) {
					Date effectDate = executeQuery.getDate("FEffectDate");
					String personId = executeQuery.getString("FPersonID");
					String id = executeQuery.getString("FID");
					if (effectDate != null) {
//						Calendar c = Calendar.getInstance();
//						c.setTime(effectDate);
//						c.add(2, (int) relativePeriod);
//						int year = c.get(1);
//						int month = c.get(2) + 1;
						String dayformat = sdf_yyyy_MM_dd.format(effectDate);
						dateMap.put(id, dayformat );
						List<String> list = (List) effectDateMap.get(dayformat);
						if (list == null) {
							list = new ArrayList();
							effectDateMap.put(dayformat, list);
						}

						((List) list).add(personId);
					}
				}
			}

			if (effectDateMap.isEmpty()) {
				return dataMap;
			}

			CmpInSql<String> instance = CmpInSqlFactory.getInstance();
			Iterator var21 = effectDateMap.entrySet().iterator();

			while (var21.hasNext()) {
				Entry<String, List<String>> entry = (Entry) var21.next();
				List<String> personList = (List) entry.getValue();
				sqlMap.put(entry.getKey(),
						instance.createInSqlBaseOnFId(ctx, personList).replace("(", "").replace(")", ""));
			}

			dataMap.put("sqlMap", sqlMap);
			dataMap.put("effectDateMap", dateMap);
		} catch (Exception var19) {
			var19.printStackTrace();
		}

		return dataMap;
	}
}