/*     */ package com.kingdee.shr.compensation.service;
/*     */ 
/*     */ import com.kingdee.bos.Context;
/*     */ import com.kingdee.eas.basedata.hraux.BasicItemInfo;
/*     */ import com.kingdee.eas.util.app.DbUtil;
/*     */ import com.kingdee.jdbc.rowset.IRowSet;
/*     */ import com.kingdee.shr.compensation.util.Base64Utils;
/*     */ import com.kingdee.shr.compensation.util.db.CmpInSql;
/*     */ import com.kingdee.shr.compensation.util.db.CmpInSqlFactory;
/*     */ import com.kingdee.shr.rpts.ctrlreport.osf.OSFExecutor;
/*     */ import com.kingdee.shr.validaterule.formula.SalaryCalFunction2;
/*     */ import java.text.SimpleDateFormat;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Calendar;
/*     */ import java.util.Date;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import org.apache.commons.lang3.StringUtils;
/*     */ import org.slf4j.Logger;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class CalSubmitSchemeFunctionService extends SalaryCalFunction2 {
/*     */    private static final Logger logger = LoggerFactory.getLogger(CalSubmitSchemeFunctionService.class);
/*     */    private final SimpleDateFormat sdf_yyyy_MM_dd = new SimpleDateFormat("yyyy-MM-dd");
/*     */    private static final String EARLIEST_EFFDT = "1900-01-01";
/*     */    private static final String MAX_ENDDATE = "2199-12-31";
/*     */ 
/*     */    public String getCurMonthPeriodEndDate(Context ctx, String mainTableName, Map paramMap, HashMap tempMap, BasicItemInfo calScheme, String mainTableRowFilter, double nullDefaultVal) {
/*  39 */       String entryId = (String)paramMap.get(mainTableName.toUpperCase(Locale.ENGLISH) + "_FID");
/*  40 */       String tempMapKey = "CalSubmitSchemeFunctionService_getCurMonthPeriodEndDate";
/*  41 */       if (tempMap.get(tempMapKey) == null) {
/*     */          try {
/*  43 */             tempMap.put(tempMapKey, this.initPeriodRecord(ctx, mainTableName, mainTableRowFilter, (String)null, new Date()));
/*  44 */          } catch (Exception var12) {
/*  45 */             logger.error(var12.getMessage(), var12);
/*  46 */             tempMap.put(tempMapKey, new HashMap());
/*     */          }      }
/*     */ 
/*  49 */       Map<String, String> result = (HashMap)tempMap.get(tempMapKey);
/*  50 */       if (result.containsKey(entryId)) {
/*  51 */          return (String)result.get(entryId);
/*     */       } else {
/*  53 */          return 0.0D == nullDefaultVal ? "1900-01-01" : "2199-12-31";
/*     */       }
/*     */    }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */    public String getCurMonEndDateForSubElement(Context ctx, String mainTableName, Map paramMap, HashMap tempMap, BasicItemInfo calScheme, String mainTableRowFilter, String submitElement, double nullDefaultVal) {
/*  73 */       if (StringUtils.isEmpty(submitElement)) {
/*  74 */          return 0.0D == nullDefaultVal ? "1900-01-01" : "2199-12-31";
/*     */       } else {
/*  76 */          String entryId = (String)paramMap.get(mainTableName.toUpperCase(Locale.ENGLISH) + "_FID");
/*     */ 
/*  78 */          String tempMapKey = "CalSubmitSchemeFunctionService_getCurMonEndDateForSubElement_" + submitElement;
/*  79 */          if (tempMap.get(tempMapKey) == null) {
/*     */             try {
/*  81 */                tempMap.put(tempMapKey, this.initPeriodRecord(ctx, mainTableName, mainTableRowFilter, submitElement, new Date()));
/*  82 */             } catch (Exception var13) {
/*  83 */                logger.error(var13.getMessage(), var13);
/*  84 */                tempMap.put(tempMapKey, new HashMap());
/*     */             }         }
/*     */ 
/*  87 */          Map<String, String> result = (HashMap)tempMap.get(tempMapKey);
/*  88 */          if (result.containsKey(entryId)) {
/*  89 */             return (String)result.get(entryId);
/*     */          } else {
/*  91 */             return 0.0D == nullDefaultVal ? "1900-01-01" : "2199-12-31";
/*     */          }
/*     */       }
/*     */    }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */    private Map<String, String> initPeriodRecord(Context ctx, String mainTableName, String mainTableRowFilter, String submitElement, Date effectDate) throws Exception {
/* 109 */       Map<String, String> result = new HashMap();
/*     */ 
/* 111 */       StringBuilder osql = new StringBuilder();
/* 112 */       osql.append("select entry.fid entryId, entry.fpersonId personId, subPeriod.fsubmitschemeid submitScheme,periodDetail.FendDate endDate from ").append(mainTableName).append(" entry ").append(" left join T_HR_SBatchSubmitShemeBill bill on bill.fid = entry.fbillId ").append(" left join T_HR_SCalSubmitPeriod subPeriod on subPeriod.fsubmitSchemeId=bill.fsubmitSchemeId ").append(" left join T_HR_SubmitPeriod period on period.fid=subPeriod.fsubmitperiodid ").append(" left join T_HR_SubmitPeriodDetail periodDetail on periodDetail.fbillId = period.fid ").append(" where subPeriod.fstate = ").append(1).append(" and periodDetail.fstate=").append(1);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 119 */       if (StringUtils.isNotEmpty(mainTableRowFilter)) {
/* 120 */          osql.append(" and entry.fid in (").append(mainTableRowFilter).append(") ");
/*     */       }
/* 122 */       if (StringUtils.isNotEmpty(submitElement)) {
/*     */ 
/* 124 */          osql.append(" and subPeriod.fsubmitElementId in (select fid from T_HR_SSubmitElement where fnumber ='").append(submitElement).append("') ");
/* 125 */          osql.append(" and entry.fsubmitElementId in (select fid from T_HR_SSubmitElement where fnumber ='").append(submitElement).append("') ");
/*     */       }
/* 127 */       osql.append(" and periodDetail.FstartDate <= {ts '").append(this.sdf_yyyy_MM_dd.format(effectDate)).append("'} and periodDetail.FendDate >= {ts '").append(this.sdf_yyyy_MM_dd.format(effectDate)).append("'}").append(" order by periodDetail.FendDate desc ");
/*     */ 
/*     */ 
/*     */ 
/* 131 */       IRowSet peroidRowSet = DbUtil.executeQuery(ctx, osql.toString());
/* 132 */       while(peroidRowSet.next()) {
/* 133 */          result.put(peroidRowSet.getString("entryId"), this.sdf_yyyy_MM_dd.format(peroidRowSet.getDate("endDate")));
/*     */       }
/* 135 */       return result;
/*     */    }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */    public double getAtsDataWithSubOrg(Context ctx, Map<String, Object> paramMap, HashMap<String, Object> tempMap, String mainTableName, String mainTableRowFilter, String project, double isVac, String company, double needSubOrg, double relativePeriod) {
/* 145 */       boolean haveSubOrg = 1.0D == needSubOrg;
/* 146 */       boolean vacProject = 1.0D == isVac;
/* 147 */       String key = "AtsResult:" + project + "-" + company + "-" + needSubOrg + "-" + isVac + "-" + relativePeriod;
/* 148 */       Map<String, List<Object>> mapData = null;
/* 149 */       List<Object> listData = null;      Map dateMap;      
/* 150 */       if (tempMap.get(key) == null) {
/*     */ 
/* 152 */          Map<String, Map<String, String>> dataMap = this.getSubDataGroupByEffectDate(ctx, mainTableName, mainTableRowFilter, relativePeriod);
/* 153 */          if (dataMap.isEmpty() || ((Map)dataMap.get("sqlMap")).isEmpty()) {
/* 154 */             return 0.0D;
/*     */          }
/* 156 */          Map<String, String> sqlMap = (Map)dataMap.get("sqlMap");
/* 157 */          dateMap = (Map)dataMap.get("effectDateMap");
/* 158 */          Iterator<String> iterator = sqlMap.keySet().iterator();
/* 159 */          HashMap param = new HashMap();
/* 160 */          while(iterator.hasNext()) {
/* 161 */             String dateKey = (String)iterator.next();
/* 162 */             String rangeSql = (String)sqlMap.get(dateKey);
/* 163 */             String[] yearAndMonth = dateKey.split("~");
/* 164 */             param.put("year", yearAndMonth[0]);
/* 165 */             param.put("month", yearAndMonth[1]);
/*     */ 
/* 167 */             String l = ctx.getLocale().getLanguage();
/*     */ 
/* 169 */             String companyLongNumber = " select fLongNumber from T_ORG_ADMIN where fid in   (select FADMINORGID  from T_ORG_ADMINORGtreehis where fDisplayName_" + l + " = '" + company + "') ";
/*     */ 
/* 171 */             param.put("companyLongNumber", Base64Utils.encodeWithSalt(companyLongNumber));
/* 172 */             param.put("personIds", Base64Utils.encodeWithSalt(rangeSql));
/* 173 */             param.put("haveSubOrg", haveSubOrg);
/* 174 */             param.put("attendProject", project);
/*     */             List tempListData;
/* 176 */             if (!vacProject) {
/* 177 */                tempListData = (List)OSFExecutor.executeOSF(ctx, param, "getAttendSumByHrOrg");
/*     */             } else {
/* 179 */                tempListData = (List)OSFExecutor.executeOSF(ctx, param, "getHolidayProjectSummary");
/*     */             }
/* 181 */             if (tempListData != null) {
/* 182 */                if (mapData == null) {
/* 183 */                   mapData = new HashMap();
/*     */                }
/* 185 */                listData = (List)mapData.get(dateKey);
/* 186 */                if (listData == null) {
/* 187 */                   listData = new ArrayList();
/* 188 */                   mapData.put(dateKey, listData);
/*     */                }
/* 190 */                ((List)listData).addAll(tempListData);
/*     */             }         }
/*     */ 
/* 193 */          tempMap.put(key, mapData);
/* 194 */          tempMap.put(key + "-effectDate", dateMap);
/*     */       }
/* 196 */       String personId = (String)paramMap.get(mainTableName.toUpperCase() + "_FPERSONID");
/* 197 */       String id = (String)paramMap.get(mainTableName.toUpperCase() + "_FID");
/* 198 */       dateMap = (Map)tempMap.get(key + "-effectDate");
/* 199 */       String dateKey = (String)dateMap.get(id);
/* 200 */       Map<String, List<Object>> resultData = (Map)tempMap.get(key);
/* 201 */       dateKey = "";
/* 202 */       HashMap<String, Object> atsResultMap = null;
/* 203 */       if (null != resultData && null != resultData.get(dateKey) && !((List)resultData.get(dateKey)).isEmpty()) {
/* 204 */          List<Object> atsResultData = (List)resultData.get(dateKey);
/* 205 */          Iterator i = atsResultData.iterator();         while(i.hasNext()) {
/* 206 */             HashMap<String, Object> map = (HashMap)i.next();
/* 207 */             dateKey = map.containsKey("personId") ? map.get("personId").toString() : "";
/* 208 */             if (dateKey.equals(personId)) {
/* 209 */                atsResultMap = map;
/* 210 */                break;
/*     */             }         }
/*     */       }
/*     */ 
/* 214 */       if (null != atsResultMap) {
/* 215 */          double res = 0.0D;
/* 216 */          if (null != atsResultMap.get(project) && !"".equals(atsResultMap.get(project))) {
/* 217 */             res = Double.parseDouble(atsResultMap.get(project).toString());
/*     */          }
/* 219 */          return res;
/*     */       } else {
/* 221 */          return 0.0D;
/*     */       }
/*     */    }
/*     */    public Map<String, Map<String, String>> getSubDataGroupByEffectDate(Context ctx, String mainTableName, String mainTableRowFilter, double relativePeriod) {
/* 225 */       String sql = "select FID, FEffectDate, FPersonID from " + mainTableName + " where FID in (" + mainTableRowFilter + ")";
/* 226 */       Map<String, List<String>> effectDateMap = new HashMap();
/* 227 */       Map<String, String> sqlMap = new HashMap();
/* 228 */       Map<String, String> dateMap = new HashMap();
/* 229 */       HashMap dataMap = new HashMap();
/*     */       try {
/* 231 */          IRowSet executeQuery = DbUtil.executeQuery(ctx, sql);
/* 232 */          if (null != executeQuery) {
/* 233 */             while(executeQuery.next()) {
/* 234 */                Date effectDate = executeQuery.getDate("FEffectDate");
/* 235 */                String personId = executeQuery.getString("FPersonID");
/* 236 */                String id = executeQuery.getString("FID");
/* 237 */                if (effectDate != null) {
/* 238 */                   Calendar c = Calendar.getInstance();
/* 239 */                   c.setTime(effectDate);
/* 240 */                   c.add(2, (int)relativePeriod);
/* 241 */                   int year = c.get(1);
/* 242 */                   int month = c.get(2) + 1;
/* 243 */                   dateMap.put(id, year + "~" + month);
/* 244 */                   List<String> list = (List)effectDateMap.get(year + "~" + month);
/* 245 */                   if (list == null) {
/* 246 */                      list = new ArrayList();
/* 247 */                      effectDateMap.put(year + "~" + month, list);
/*     */                   }
/* 249 */                   ((List)list).add(personId);
/*     */                }            }         }
/*     */ 
/* 252 */          if (effectDateMap.isEmpty()) {            return dataMap;         }
/* 253 */          CmpInSql<String> instance = CmpInSqlFactory.getInstance();
/* 254 */          Iterator var21 = effectDateMap.entrySet().iterator();         while(var21.hasNext()) {            Entry<String, List<String>> entry = (Entry)var21.next();
/* 255 */             List<String> personList = (List)entry.getValue();
/* 256 */             sqlMap.put(entry.getKey(), instance.createInSqlBaseOnFId(ctx, personList).replace("(", "").replace(")", ""));
/*     */          }
/* 258 */          dataMap.put("sqlMap", sqlMap);
/* 259 */          dataMap.put("effectDateMap", dateMap);
/* 260 */       } catch (Exception var19) {
/* 261 */          var19.printStackTrace();
/*     */       }
/* 263 */       return dataMap;
/*     */    }
/*     */ }
