package com.kingdee.shr.compensation.web.handler.timepiece.bill;


import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.ToolUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillEntryCollection;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillEntryFactory;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillEntryInfo;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillInfo;
import com.kingdee.shr.compensation.app.integrate.CalSubmitItemCollection;
import com.kingdee.shr.compensation.app.integrate.CalSubmitItemFactory;
import com.kingdee.shr.compensation.app.integrate.CalSubmitItemInfo;
import com.kingdee.shr.compensation.app.integrate.IBatchSubmitShemeBillEntry;
import com.kingdee.shr.compensation.exception.ExceptionHandle;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.ObjectUtils;
import org.springframework.ui.ModelMap;


/**
 * ᱨչ
 * @author coyle
 * 20250520
 */
public class TimepieceSchemeBillEditHandlerEx extends TimepieceSchemeBillEditHandler {

	private static  SimpleDateFormat  SDF = new SimpleDateFormat("yyyy-MM-dd");
	//  		 		
	private static String COMRATE = "MQ005";
	//λ
	private static String JOBTYPE = "MQ004";
	//ܵȼ SKILLLEVEL
	private static String SKILLLEVEL = "MQ003";
	//Ƿֳҵ On site
	private static String ONSITE = "MQ007";
	//ְ Team app
	private static String TEAMAPP = "MQ007";
	// Salary seq
	private static String SALARYSEQ = "MQ007";
	
	private static String[] ITEMNUMS = {COMRATE,JOBTYPE,SKILLLEVEL,ONSITE,TEAMAPP,SALARYSEQ};
	
	private static Map<String,String> FEILDS = new HashMap();
	
 

	
	public TimepieceSchemeBillEditHandlerEx() throws BOSException {
		Context ctx = SHRContext.getInstance().getContext();
		CalSubmitItemCollection subColl = CalSubmitItemFactory.getLocalInstance(ctx)
				.getCalSubmitItemCollection("SELECT ID,FieldSn,number  where  number in (" + ToolUtils.aryToStr(ITEMNUMS) + ")");
		if (subColl != null && subColl.size() > 0) {
			for (int i =0 ;i<subColl.size();i++) {
				CalSubmitItemInfo itemInfo = subColl.get(i);
				if (itemInfo != null) {
					String columnName = "S" + itemInfo.getFieldSn();
					FEILDS.put(itemInfo.getNumber() , columnName);
				}
			}
		}
	}


	
	protected void beforeSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model)
			throws SHRWebException {
		super.beforeSave(request, response, model);
		BatchSubmitShemeBillInfo info = (BatchSubmitShemeBillInfo) model;
		BatchSubmitShemeBillEntryCollection entry = info.getEntry();
		String billId = "";
		if(ObjectUtils.allNotNull(info.getId())) {
			billId = info.getId().toString();
		}
		//ȡmes
		exeDataOnDay(billId,entry);
		
		
	 
	}
	
	
	
	/**
	 * õ
	 * @param billId
	 * @param entrys
	 * @throws SHRWebException
	 */
	public void setMesData(Context ctx,String billId,BatchSubmitShemeBillEntryCollection entrys,HashMap<String, HashMap> mesData ) throws SHRWebException {
//		Map<String, Set<String>> personDateMap = new HashMap<>();
		for (int i = 0; i < entrys.size(); i++) {
			BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
			String pId = entry.getPerson().getId().toString();
			Date effectDate = entry.getEffectDate();
			String eDate = SDF.format(effectDate);
			String key = pId+"_"+eDate;
			HashMap  valMap = mesData.get(key);
			if(ObjectUtils.isEmpty(valMap)) {
				continue;
			}
			for (String field : FEILDS.keySet()) {  // ʹ ITEMNUMS
				String sVal = FEILDS.get(field);
				if (entry.containsKey(sVal)) {
					entry.put(sVal, valMap.get(sVal));  // Ϊ 0 Ĭֵ
				}
			}
		}
	}
	
	
	
	/**
	 * мȡmes
	 */
	private HashMap<String,HashMap>  getMesData(Context ctx ,HashSet<String> selectPerson,DateRange dateRange) {
		HashMap<String,HashMap> checkMap =  new HashMap();
		Set<String>  checkbillIds = new HashSet();
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		try {
			String sql = " select fid ,CFComrate, cfpersonId, cfpositiontype , cfskillLevel , onSite , teamApp , salarysEq ,"
					+ " fbizDate  "
					+ " from  CT_CAL_InspectionRate  where cfpersonid in "
					+ "( "
					+ ToolUtils.aryToStr(selectPerson,true) 
					+ " ) "
					+ " and cfbizDate >= '"
					+ dateFormat.format(dateRange.getMinDate()) 
					+ "' and  cfbizDate <= '" 
					+ dateFormat.format(dateRange.getMaxDate()) 
					+"'" ;
			
			IRowSet rst =  DbUtil.executeQuery(ctx, sql);
			while( rst.next() ) {
				//id
				String checkbillId  = rst.getString("fid");
				checkbillIds.add(checkbillId);
				String pId = rst.getString("cfPersonId");
				Date bizDate = rst.getDate("fbizDate");
				String eDate = SDF.format(bizDate);
				String key = pId+"_"+eDate;
				HashMap<String,String> valMap = new HashMap(); 
				BigDecimal comrate = rst.getBigDecimal("CFComrate");
				valMap.put(FEILDS.get(COMRATE), comrate.toString());
				//
				valMap.put(FEILDS.get(JOBTYPE), rst.getString("cfpositiontype"));
				valMap.put(FEILDS.get(SKILLLEVEL), rst.getString("cfskillLevel"));
				valMap.put(FEILDS.get(ONSITE), rst.getString("onSite"));
				valMap.put(FEILDS.get(TEAMAPP), rst.getString("teamApp"));
				valMap.put(FEILDS.get(SALARYSEQ), rst.getString("salarysEq"));
				checkMap.put(key, valMap);
			}
		}catch(BOSException e){
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return checkMap;
						
	}
	
	
	
	
	/**
	 * ݴ
	 * УӦĳһѴ/mesݻȡ
	 * @param billId
	 * @param entrys
	 * @throws SHRWebException
	 */
	public void exeDataOnDay(String billId,BatchSubmitShemeBillEntryCollection entrys) throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		Map<String, Set<String>> personDateMap = new HashMap<>();
		//
		HashSet<String> selectPerson = new HashSet();
		HashSet<String> selectDate = new HashSet();
		for (int i = 0; i < entrys.size(); i++) {
			BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
			String personId = entry.getPerson().getId().toString();
			selectPerson.add(personId);
			Date effectDate = entry.getEffectDate();
			// Ӷ effectDate Ϊ null ļ
			if (effectDate == null) {
				throw new IllegalArgumentException("¼зڲΪ,");
			}
			String formattedEffectDate = SDF.format(effectDate);
			selectDate.add(formattedEffectDate);
			// ʹ computeIfAbsent 룬ظ
			personDateMap.computeIfAbsent(personId, k -> new HashSet<>());
			if (!personDateMap.get(personId).add(formattedEffectDate)) {
				//  add  false˵Ѿڣ׳쳣
				throw new IllegalArgumentException("¼" + entry.getPerson().getName() + ",еظᱨ,");
			}
		
		}
		
		if (personDateMap.isEmpty()) {
			return;
		}
		// ҳС
		DateRange dateRange = findMinMaxDate(selectDate);
		//Уظ
		verifiOneData(ctx, billId, selectPerson, dateRange, personDateMap);
		//Уmes;
		//ȡmes
		HashMap<String, HashMap> mesData = getMesData(ctx, selectPerson, dateRange);
		setMesData(ctx, billId, entrys, mesData);
	}
	
	
	
	
 
	
	/**
	 * У鵱Ƿظ
	 * @param ctx
	 * @param billId
	 * @param selectPerson
	 * @param dateRange
	 * @param personDateMap
	 * @throws SHRWebException 
	 */
	public void verifiOneData(Context ctx ,String billId,HashSet<String> selectPerson,DateRange dateRange,Map<String, Set<String>> personDateMap) throws SHRWebException {
		HashMap<String,String> dataMap = new HashMap();
		try {
			IBatchSubmitShemeBillEntry entryIns = BatchSubmitShemeBillEntryFactory.getLocalInstance(ctx);
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("person", selectPerson, CompareType.INCLUDE));
			filter.getFilterItems().add(new FilterItemInfo("bill.id",   billId , CompareType.NOTEQUALS  ));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMaxDate() , CompareType.LESS_EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMinDate() , CompareType.GREATER_EQUALS  ));
			EntityViewInfo viewInfo = new EntityViewInfo();
			SelectorItemCollection selector = viewInfo.getSelector();
			selector.add(new SelectorItemInfo("person.id"));
			selector.add(new SelectorItemInfo("person.name"));
			selector.add(new SelectorItemInfo("bill.number"));
			selector.add(new SelectorItemInfo("effectDate"));
			viewInfo.setFilter(filter);
			BatchSubmitShemeBillEntryCollection entryCol = entryIns.getBatchSubmitShemeBillEntryCollection(viewInfo);
			for(int i = 0;i<entryCol.size();i++) {
				BatchSubmitShemeBillEntryInfo entryInfo  = entryCol.get(i);
				Date effectDate = entryInfo.getEffectDate();
				String  personId = entryInfo.getPerson().getId().toString();
				Set<String> pAndDate = personDateMap.get(personId);
				if(pAndDate.contains(SDF.format(effectDate))) {
					String  personName = entryInfo.getPerson().getName().toString();
					BatchSubmitShemeBillInfo billInfo = entryInfo.getBill();
					String billNo = billInfo.getNumber();
					dataMap.put(personName, billNo);
				}
			}
		 
		} catch (BOSException e) {
			e.printStackTrace();
		}
		 //dataMapΪѭdataMapַ׳쳣,"Щ,ݱΪ:****"
		if(!dataMap.isEmpty()) {
			String errorMsg = "µظᱨԱ,뵥ݱΪ:";
			for(String personName : dataMap.keySet()) {
				String billNo = dataMap.get(personName);
				errorMsg += personName + ":" + billNo + "  ";
			}
			throw new SHRWebException(errorMsg);
		}
	}
	
	
	
	
	
	
	/**
	 * handlerУ,Ȳ
	 * @param request
	 * @param response
	 * @param modelMap
	 * @throws SHRWebException
	 */
	public void hasDataOnDayAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		// ȡԱ //ʽΪ[pseron1:2025-04-03,person2:2025-04-03],ҪתΪmap
		String proposers = request.getParameter("proposers");
		if (proposers == null || proposers.isEmpty()) {
			return;
		}
		 
		String[] personArr = proposers.split(",");
		HashSet<String> selectPerson = new HashSet();
		HashSet<String> selectData = new HashSet();
		Map<String, Set<String>> personDateMap = new HashMap<>();
		for (int i = 0; i< personArr.length;i++) {
			String personIds = personArr[i];
			String[] parts = personIds.split(":");
			if (parts.length == 2) {
				String personId = parts[0].trim();
				String date = parts[1].trim();
				selectPerson.add(personId);
				selectData.add(date);
				personDateMap.computeIfAbsent(personId, k -> new HashSet<>()).add(date);
			}
		}

		if (personDateMap.isEmpty()) {
			return;
		}
		
		HashMap<String,String> dataMap = new HashMap();
		
		// ҳС
		DateRange dateRange = findMinMaxDate(selectData);
		IBatchSubmitShemeBillEntry entryIns;
		try {
			entryIns = BatchSubmitShemeBillEntryFactory.getLocalInstance(ctx);
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("proposer", selectPerson, CompareType.INCLUDE));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMaxDate() , CompareType.LESS_EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMinDate() , CompareType.GREATER_EQUALS  ));
			EntityViewInfo viewInfo = new EntityViewInfo();
			viewInfo.setFilter(filter);
			BatchSubmitShemeBillEntryCollection entryCol = entryIns.getBatchSubmitShemeBillEntryCollection(viewInfo);
			for(int i = 0;i<entryCol.size();i++) {
				BatchSubmitShemeBillEntryInfo entryInfo  = entryCol.get(i);
				Date effectDate = entryInfo.getEffectDate();
				String  personId = entryInfo.getPerson().getId().toString();
				Set<String> pAndDate = personDateMap.get(personId);
				if(pAndDate.contains(SDF.format(effectDate))) {
					String  personName = entryInfo.getPerson().getName().toString();
					BatchSubmitShemeBillInfo billInfo = entryInfo.getBill();
					String billNo = billInfo.getNumber();
					dataMap.put(personName, billNo);
				}
			}
		 
		} catch (BOSException e) {
			e.printStackTrace();
		}
		Map resultMap = new HashMap();
		JSONUtils.SUCCESS( resultMap );
	}



	private DateRange findMinMaxDate(HashSet<String> subDate) {
		if (subDate == null || subDate.isEmpty()) {
			return null;
		}

		List<Date> dates = new ArrayList<>();
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		for (String dateString : subDate) {
			try {
				dates.add(dateFormat.parse(dateString.trim()));
			} catch (ParseException e) {
				// ڸʽȷ
				e.printStackTrace();
				return null; // ڸʽȷֱӷ null
			}
		}
		if (dates.isEmpty()) {
			return null;
		}

		Date minDate = Collections.min(dates);
		Date maxDate = Collections.max(dates);

		return new DateRange(minDate, maxDate);
	}

	// һ洢ڷΧ
	private static class DateRange {
		private final Date minDate;
		private final Date maxDate;

		public DateRange(Date minDate, Date maxDate) {
			this.minDate = minDate;
			this.maxDate = maxDate;
		}

		public Date getMinDate() {
			return minDate;
		}

		public Date getMaxDate() {
			return maxDate;
		}
	}
	
	
	
	
	protected void afterSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model)
			throws SHRWebException {
		super.afterSave(request, response, model);
		BatchSubmitShemeBillInfo info = (BatchSubmitShemeBillInfo) model;
		BatchSubmitShemeBillEntryCollection entry = info.getEntry();
		String billId = "";
		if(ObjectUtils.allNotNull(info.getId())) {
			billId = info.getId().toString();
		}
//		exeDataOnDay(billId,entry);
		 
	}
	
	
	 
	public void getDataOnDay(String billId,BatchSubmitShemeBillEntryCollection entrys) throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		Map<String, Set<String>> personDateMap = new HashMap<>();
		//
		HashSet<String> selectPerson = new HashSet();
		HashSet<String> selectDate = new HashSet();
		for (int i = 0; i < entrys.size(); i++) {
			BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
			String personId = entry.getPerson().getId().toString();
			selectPerson.add(personId);
			Date effectDate = entry.getEffectDate();
		
			String formattedEffectDate = SDF.format(effectDate);
			selectDate.add(formattedEffectDate);
			// ʹ computeIfAbsent 룬ظ
			personDateMap.computeIfAbsent(personId, k -> new HashSet<>());
			if (!personDateMap.get(personId).add(formattedEffectDate)) {
				//  add  false˵Ѿڣ׳쳣
				throw new IllegalArgumentException("¼" + entry.getPerson().getName() + ",еظᱨ,");
			}
		}
		
		if (personDateMap.isEmpty()) {
			return;
		}
		// ҳС
		DateRange dateRange = findMinMaxDate(selectDate);
		//Уظ
		verifiOneData(ctx, billId, selectPerson, dateRange, personDateMap);
		//ȡmes
		HashMap<String, HashMap> mesData = getMesData(ctx, selectPerson, dateRange);
		setMesData(ctx, billId, entrys, mesData);
	}
	
	
	public String saveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		try {
			BatchSubmitShemeBillInfo model = (BatchSubmitShemeBillInfo) request.getAttribute("dynamic_model");
			this.doFieldPermFilterSave(request, model);
			this.doSave(request, response, model);
			this.afterSave(request, response, model);
			this.saveAttachment(request, response, model);
			Object responseData = this.generateResponseDataAfterSave(request, response, model);
			this.writeSuccessData(responseData);
		} catch (Exception var6) {
			ExceptionHandle.handleException(var6);
		}

		return null;
	}
}
